// SRecDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "SRec.h"
#include "SRecDlg.h"

#include "GogoConfDlg.h"

#include "Mp3Thread.h"
#include "gogo/Musenc.h"

#include "fft.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define LX 12
#define RX 148
#define LY 16
#define RY 16

#define RW 128
#define LH 32
#define RH 32


/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_strGogo;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_strGogo = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_EDIT_GOGO, m_strGogo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSRecDlg _CAO

CSRecDlg::CSRecDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSRecDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSRecDlg)
	m_dwEditThreshold = 0;
	m_nStopHour = 0;
	m_nStopMin = 0;
	m_dwEditSilentTimeSpan = 0;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nSilent = 2;	// L͕s
	m_nTimer = 0;
}

void CSRecDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSRecDlg)
	DDX_Control(pDX, IDC_CHECK_WMA, m_CheckWma);
	DDX_Control(pDX, IDC_EDIT_SILENT_TIME_SPAN, m_editSilentTimeSpan);
	DDX_Control(pDX, IDC_CHECK_STARTNOW, m_CheckStartnow);
	DDX_Control(pDX, IDC_CHECK_POWERDOWN, m_CheckPowerdown);
	DDX_Control(pDX, IDC_CHECK_TIMESTAMP, m_CheckTimestamp);
	DDX_Control(pDX, IDC_EDT_TIMER_STAT, m_edtTimerStat);
	DDX_Control(pDX, IDC_DTPD_START, m_dtpdStart);
	DDX_Control(pDX, IDC_BTN_TIMER, m_BtnTimer);
	DDX_Control(pDX, IDC_DTPT_START, m_dtptStart);
	DDX_Control(pDX, IDC_EDT_STOP_MIN, m_edtStopMin);
	DDX_Control(pDX, IDC_EDT_STOP_HOUR, m_edtStopHour);
	DDX_Control(pDX, IDC_BTN_SKIP, m_BtnSkip);
	DDX_Control(pDX, IDC_BTN_GOGOCONF, m_BtnGogoInf);
	DDX_Control(pDX, IDC_PRGR_NORMALIZE, m_prgrNormalize);
	DDX_Control(pDX, IDC_PRGR_4844, m_prgr4844);
	DDX_Control(pDX, IDC_CHECK_4844, m_Check4844);
	DDX_Control(pDX, IDC_CHECK_NORMALIZE, m_CheckNormalize);
	DDX_Control(pDX, IDC_EDIT_MP3_COUNTDOWN, m_editMp3Countdown);
	DDX_Control(pDX, IDC_PRGR_MP3, m_prgrMp3);
	DDX_Control(pDX, IDC_EDIT_THRESHOLD, m_editThreshold);
	DDX_Control(pDX, IDC_CHECK_WAV, m_CheckWav);
	DDX_Control(pDX, IDC_CHECK_MP3, m_CheckMp3);
	DDX_Control(pDX, IDC_EDIT_FLD, m_editFld);
	DDX_Control(pDX, IDC_EDIT_FILEPRE, m_editFilepre);
	DDX_Control(pDX, IDC_EDIT_REC_STATUS, m_editRecStatus);
	DDX_Control(pDX, IDC_EDIT_FILENAME, m_editFileName);
	DDX_Text(pDX, IDC_EDIT_THRESHOLD, m_dwEditThreshold);
	DDV_MinMaxDWord(pDX, m_dwEditThreshold, 0, 32768);
	DDX_Text(pDX, IDC_EDT_STOP_HOUR, m_nStopHour);
	DDV_MinMaxUInt(pDX, m_nStopHour, 0, 240);
	DDX_Text(pDX, IDC_EDT_STOP_MIN, m_nStopMin);
	DDV_MinMaxUInt(pDX, m_nStopMin, 0, 14440);
	DDX_Text(pDX, IDC_EDIT_SILENT_TIME_SPAN, m_dwEditSilentTimeSpan);
	DDV_MinMaxDWord(pDX, m_dwEditSilentTimeSpan, 0, 32767);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSRecDlg, CDialog)
	//{{AFX_MSG_MAP(CSRecDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REC, OnRec)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_BTN_REF, OnBtnRef)
	ON_EN_CHANGE(IDC_EDIT_FILEPRE, OnChangeEditFilepre)
	ON_EN_CHANGE(IDC_EDIT_FLD, OnChangeEditFld)
	ON_MESSAGE(MM_WIM_DATA, OnMmWinData)
	ON_BN_CLICKED(IDC_RADIO_SPECTRUM, OnRadioSpectrum)
	ON_BN_CLICKED(IDC_RADIO_LEVEL, OnRadioLevel)
	ON_BN_CLICKED(IDC_CHECK_MP3, OnCheckMp3)
	ON_BN_CLICKED(IDC_CHECK_WAV, OnCheckWav)
	ON_BN_CLICKED(IDC_BTN_THRESHOLD, OnBtnThreshold)
	ON_EN_KILLFOCUS(IDC_EDIT_THRESHOLD, OnKillfocusEditThreshold)
	ON_BN_CLICKED(IDC_CHECK_NORMALIZE, OnCheckNormalize)
	ON_BN_CLICKED(IDC_CHECK_4844, OnCheck4844)
	ON_BN_CLICKED(IDC_RADIO_32, OnRadio32)
	ON_BN_CLICKED(IDC_RADIO_44, OnRadio44)
	ON_BN_CLICKED(IDC_RADIO_48, OnRadio48)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BTN_GOGOCONF, OnBtnGogoconf)
	ON_BN_CLICKED(IDC_BTN_SKIP, OnBtnSkip)
	ON_BN_CLICKED(IDC_BTN_TIMER, OnBtnTimer)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_TIMESTAMP, OnCheckTimestamp)
	ON_BN_CLICKED(IDC_CHECK_STARTNOW, OnCheckStartnow)
	ON_BN_CLICKED(IDC_CHECK_POWERDOWN, OnCheckPowerdown)
	ON_THREAD_MESSAGE(WM_MP3THREADEND, OnMp3ThreadEnd )
	ON_EN_KILLFOCUS(IDC_EDIT_SILENT_TIME_SPAN, OnKillfocusEditSilentTimeSpan)
	ON_BN_CLICKED(IDC_BTN_ABOUT, OnBtnAbout)
	ON_BN_CLICKED(IDC_CHECK_WMA, OnCheckWma)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSRecDlg bZ[W nh
void CSRecDlg::ReadIni()
{
	CString strIniPathName = ((CSRecApp*)AfxGetApp())->m_strExeFolder+"\\srec.ini";

	{
		// GR[h[h MC_MODE_ MONO,STEREO,JOINT,MSSTEREO,DUALCHANNEL
		m_GogoSetting.dwEncodeMode = MC_MODE_JOINT;
		// rbg[g     32,40,48,56,64,80,96,112,128,160,192,224,256,320 
		m_GogoSetting.dwBitRate = 128;
		// S         FALSE( or 0 ),
		m_GogoSetting.dwUsePsy = FALSE;
		// [pXtB^ TRUE( or !0 ), 
		m_GogoSetting.dwUseLpf16 = TRUE;
		// Gt@VX     MC_EMP_NONE MC_EMP_5015MS MC_EMP_CCITT
		m_GogoSetting.dwEmphasis = MC_EMP_NONE;
		// σrbg[g 0`9
		m_GogoSetting.bVbr  = FALSE;
		m_GogoSetting.dwVbr = 5;
		// o̓TvOg 16000 22050 24000 32000 44100 48000
		m_GogoSetting.bOutFreq  = FALSE;
		m_GogoSetting.dwOutFreq = 44100;
	}
	{
		m_strFld = _T(".");
		m_strFilepre = _T("music");
		m_dwEditThreshold = 0;
		m_dwEditSilentTimeSpan = 1;
		m_dispMode = 1;
		m_bCheckNormalize = false;
		m_nNormalizeLevel = 0;
		m_bCheck4844 = false;
		m_bCheckWav = true;
		m_bCheckMp3 = false;
		m_bCheckWma = false;
		m_bCheckTimestamp = false;
		m_nPriGapLen  = 0;	// ȑO̖Tv
		m_nPostGapLen = 0;	// Ȍ̖Tv
		m_fpDebugLog = NULL;
		m_nThreadPriority = THREAD_PRIORITY_NORMAL;	// ϊXbh̃vCIeB
		//m_strDebugLogFileName;
		m_nDebugLogLevel = 0;

		m_bTimerSetByIniFile = false;
	}
	
	char buff[1024];
	FILE *fp;
	fp = fopen(strIniPathName,"rt");
	if ( fp == NULL ) {
		m_bIniModified = true;
		return;
	}

	m_bIniModified = false;

	while ( !feof(fp) ) {
		char *name,*value;
		if ( fgets(buff,1024,fp) == NULL ) continue;

		if ( buff[0] == '#' ) continue;

		name = buff;
		value = strchr(buff,'=');
		if ( value == NULL ) continue;
		value[0] = '\0';
		value++;

		if ( strcmp(buff,"RecSamplesPerSec")==0 ) {
			ULONG ul = atoi(value);
			/*
			if ( ul != 32000 && ul != 44100 && ul!= 48000 ) {
				ul = 44100;
			}
			*/
			m_wfx.nSamplesPerSec = ul;
		}
		else if ( strcmp(buff,"RecFolder")==0 ) {
			if ( value[strlen(value)-1] == '\n' ) value[strlen(value)-1] = '\0';
			m_strFld = value;
		}
		else if ( strcmp(buff,"RecFilePre")==0 ) {
			if ( value[strlen(value)-1] == '\n' ) value[strlen(value)-1] = '\0';
			m_strFilepre = value;
		}
		else if ( strcmp(buff,"RecSilentThreshold")==0 ) {
			DWORD dw = atoi(value);
			m_dwEditThreshold = dw;
		}
		else if ( strcmp(buff,"RecSilentTimeSpan")==0 ) {
			DWORD dw = atoi(value);
			m_dwEditSilentTimeSpan = dw;
		}
		else if ( strcmp(buff,"RecMeterType")==0 ) {
			DWORD dw = atoi(value);
			m_dispMode = dw;
		}
		else if ( strcmp(buff,"RecNormalize")==0 ) {
			DWORD dw = atoi(value);
			m_bCheckNormalize = dw?true:false;
		}
		else if ( strcmp(buff,"NormalizeLevel")==0 ) {
			DWORD dw = atoi(value);
			m_nNormalizeLevel = dw;	// Kx
		}
		else if ( strcmp(buff,"Rec4844")==0 ) {
			DWORD dw = atoi(value);
			m_bCheck4844 = dw?true:false;
		}
		else if ( strcmp(buff,"RecWav")==0 ) {
			DWORD dw = atoi(value);
			m_bCheckWav = dw?true:false;
		}
		else if ( strcmp(buff,"RecMp3")==0 ) {
			DWORD dw = atoi(value);
			m_bCheckMp3 = dw?true:false;
		}
		else if ( strcmp(buff,"RecWma")==0 ) {
			DWORD dw = atoi(value);
			m_bCheckWma = dw?true:false;
		}
		else if ( strcmp(buff,"ChangeTimestamp")==0 ) {
			DWORD dw = atoi(value);
			m_bCheckTimestamp = dw?true:false;
		}
		else if ( strcmp(buff,"PriGapLen")==0 ) {
			DWORD dw = atoi(value);
			m_nPriGapLen = dw;	// ȑO̖Tv
		}
		else if ( strcmp(buff,"PostGapLen")==0 ) {
			DWORD dw = atoi(value);
			m_nPostGapLen = dw;	// Ȍ̖Tv
		}
		else if ( strcmp(buff,"TransThreadPriority")==0 ) {
			DWORD dw = atoi(value);
			m_nThreadPriority = dw;	// ϊXbh̃vCIeB
		}
		else if ( strcmp(buff,"DebugLogFileName")==0 ) {
			if ( value[strlen(value)-1] == '\n' ) value[strlen(value)-1] = '\0';
			m_strDebugLogFileName = value;
		}
		else if ( strcmp(buff,"DebugLogLevel")==0 ) {
			DWORD dw = atoi(value);
			m_nDebugLogLevel = dw;
		}

// Mp3 (GOGO.DLL)
		else if ( strcmp(buff,"MC_ENCODEMODE")==0 ) {
			DWORD dw = atoi(value);
			m_GogoSetting.dwEncodeMode = dw;
		}
		else if ( strcmp(buff,"MC_BITRATE")==0 ) {
			DWORD dw = atoi(value);
			m_GogoSetting.dwBitRate = dw;
		}
		else if ( strcmp(buff,"MC_USEPSY")==0 ) {
			DWORD dw = atoi(value);
			m_GogoSetting.dwUsePsy = dw;
		}
		else if ( strcmp(buff,"MC_USELPF16")==0 ) {
			DWORD dw = atoi(value);
			m_GogoSetting.dwUseLpf16 = dw;
		}
		else if ( strcmp(buff,"MC_EMPHASIS")==0 ) {
			DWORD dw = atoi(value);
			m_GogoSetting.dwEmphasis = dw;
		}
		else if ( strcmp(buff,"MC_BOOL_VBR")==0 ) {
			DWORD dw = atoi(value);
			m_GogoSetting.bVbr = dw;
		}
		else if ( strcmp(buff,"MC_VBR")==0 ) {
			DWORD dw = atoi(value);
			m_GogoSetting.dwVbr = dw;
		}
		else if ( strcmp(buff,"MC_BOOL_OUTFREQ")==0 ) {
			DWORD dw = atoi(value);
			m_GogoSetting.bOutFreq = dw;
		}
		else if ( strcmp(buff,"MC_OUTFREQ")==0 ) {
			DWORD dw = atoi(value);
			m_GogoSetting.dwOutFreq = dw;
		}

		else if ( strcmp(buff,"TIMER_ENABLE")==0 ) {
			m_bTimerSetByIniFile = true;
		}
		else if ( strcmp(buff,"TM_START")==0 ) {
			time_t tt = atol(value);
			m_timerStart = CTime(tt);
		}
		else if ( strcmp(buff,"TM_END")==0 ) {
			time_t tt = atol(value);
			m_timerEnd = CTime(tt);
		}
		else if ( strcmp(buff,"TM_POWERDOWN")==0 ) {
			DWORD dw = atoi(value);
			m_bCheckPowerdown = dw?true:false;
		}
	}
	fclose(fp);
}

void CSRecDlg::WriteIni()
{
	// if ( !m_bIniModified ) return;

	CString strIniPathName = ((CSRecApp*)AfxGetApp())->m_strExeFolder+"\\srec.ini";

	FILE *fp;
	fp = fopen(strIniPathName,"wt");
	if ( fp == NULL ) return;

	fprintf(fp,"RecSamplesPerSec=%d\n",m_wfx.nSamplesPerSec);
	fprintf(fp,"RecFolder=%s\n",(LPCTSTR)m_strFld);
	fprintf(fp,"RecFilePre=%s\n",(LPCTSTR)m_strFilepre);
	fprintf(fp,"RecSilentThreshold=%d\n",m_dwEditThreshold);
	fprintf(fp,"RecSilentTimeSpan=%d\n",m_dwEditSilentTimeSpan);
	fprintf(fp,"RecMeterType=%d\n",m_dispMode);
	fprintf(fp,"RecNormalize=%d\n",m_bCheckNormalize);
	fprintf(fp,"NormalizeLevel=%d\n",m_nNormalizeLevel);	// Kx
	fprintf(fp,"Rec4844=%d\n",m_bCheck4844?1:0);
	fprintf(fp,"RecWav=%d\n",m_bCheckWav?1:0);
	fprintf(fp,"RecMp3=%d\n",m_bCheckMp3?1:0);
	fprintf(fp,"RecWma=%d\n",m_bCheckWma?1:0);
	fprintf(fp,"ChangeTimestamp=%d\n",m_bCheckTimestamp?1:0);
	fprintf(fp,"PriGapLen=%d\n",m_nPriGapLen);		// ȑO̖Tv
	fprintf(fp,"PostGapLen=%d\n",m_nPostGapLen);	// Ȍ̖Tv
	fprintf(fp,"TransThreadPriority=%d\n",m_nThreadPriority);	// Ȍ̖Tv
	fprintf(fp,"DebugLogFileName=%s\n",(LPCTSTR)m_strDebugLogFileName);
	fprintf(fp,"#DebugLogLevel͉L̒lORłB\n");
	fprintf(fp,"# 1:KxO  2: 4: 8: ...\n");
	fprintf(fp,"DebugLogLevel=%d\n",m_nDebugLogLevel);

// MP3 (GOGO.DLL)
	fprintf(fp,"MC_ENCODEMODE=%d\n",m_GogoSetting.dwEncodeMode);
	fprintf(fp,"MC_BITRATE=%d\n",m_GogoSetting.dwBitRate);
	fprintf(fp,"MC_USEPSY=%d\n",m_GogoSetting.dwUsePsy);
	fprintf(fp,"MC_USELPF16=%d\n",m_GogoSetting.dwUseLpf16);
	fprintf(fp,"MC_EMPHASIS=%d\n",m_GogoSetting.dwEmphasis);
	fprintf(fp,"MC_BOOL_VBR=%d\n",m_GogoSetting.bVbr);
	fprintf(fp,"MC_VBR=%d\n",m_GogoSetting.dwVbr);
	fprintf(fp,"MC_BOOL_OUTFREQ=%d\n",m_GogoSetting.bOutFreq);
	fprintf(fp,"MC_OUTFREQ=%d\n",m_GogoSetting.dwOutFreq);

	if ( m_nTimerStatus == 1 ) {
		// CɊJnEI1bȂ悤ɂĂ̂ŁA
		// ␳B
		CTimeSpan ts = CTimeSpan( 0, 0, 0, 1);
		m_timerStart = m_timerStart + ts;
		m_timerEnd = m_timerEnd - ts;

		fprintf(fp,"TIMER_ENABLE=1\n");
		fprintf(fp,"TM_START=%d\n",m_timerStart.GetTime());
		fprintf(fp,"TM_END=%d\n",m_timerEnd.GetTime());
		fprintf(fp,"TM_POWERDOWN=%d\n",m_bCheckPowerdown);
	}
	fclose(fp);
}

BOOL CSRecDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	
	SinCosTblInit();

	// ^`
	m_wfx.wFormatTag = WAVE_FORMAT_PCM;
	m_wfx.nChannels = 2;
	m_wfx.nSamplesPerSec = 44100;
	m_wfx.wBitsPerSample =  16;
	m_wfx.nBlockAlign = m_wfx.nChannels * m_wfx.wBitsPerSample / 8;
	m_wfx.nAvgBytesPerSec = m_wfx.nBlockAlign * m_wfx.nSamplesPerSec;
	m_wfx.cbSize = 0;

	ReadIni();	//////////////// ݒt@CǍ

	// 񂪂ɂoO (BBS No.80)
	m_wfx.nAvgBytesPerSec = m_wfx.nBlockAlign * m_wfx.nSamplesPerSec;

	if ( m_nDebugLogLevel != 0 ) {
		m_fpDebugLog = fopen(this->m_strDebugLogFileName,"at");
		if ( m_fpDebugLog != NULL ) {
			fprintf(m_fpDebugLog,"start logging...\n");
		}
	}

	DispModeCheck();

	m_bRecording = FALSE;
	m_fp = NULL;
	m_hwi = 0;

	m_fileNum = 0;
	m_bSkip = false;

	m_dwSilentCount = 0;

	//m_editRecStatus.SetWindowText(_T("~"));
	//m_strFld = _T(".");
	//m_strFilepre = _T("music");

	m_editFld.SetWindowText( m_strFld );
	m_editFilepre.SetWindowText( m_strFilepre );

	m_editMp3Countdown.SetWindowText(_T("0"));

	{
		CAboutDlg dlgAbout;
		m_CheckWav.SetCheck(m_bCheckWav?1:0);
		m_CheckMp3.SetCheck(m_bCheckMp3?1:0);
		m_CheckWma.SetCheck(m_bCheckWma?1:0);

		if ( !m_bExistGogo ) {
			m_CheckMp3.SetCheck(0);
			m_CheckMp3.EnableWindow(FALSE);
			m_BtnGogoInf.EnableWindow(FALSE);
			m_bCheckMp3 = false;
		}
		if ( g_Wma.m_WMAudioCreateWriter == NULL ) {
			m_CheckWma.SetCheck(0);
			m_CheckWma.EnableWindow(FALSE);
			//m_BtnGogoInf.EnableWindow(FALSE);
			m_bCheckWma = false;
		}
	}

	m_CheckNormalize.SetCheck(m_bCheckNormalize?1:0);
	m_CheckTimestamp.SetCheck(m_bCheckTimestamp?1:0);

	SamplingRateCheck();

	switch ( m_wfx.nSamplesPerSec ) {
	case 48000:
		m_Check4844.SetCheck(m_bCheck4844?1:0);
		break;
	//case 32000:
	//case 44100:
	default:
		m_bCheck4844 = false;
		m_Check4844.SetCheck(0);
		m_Check4844.EnableWindow(FALSE);
		break;
	}

	CString str;
	str.Format("%d",m_dwEditThreshold);
	m_editThreshold.SetWindowText(str);
	str.Format("%d",m_dwEditSilentTimeSpan);
	m_editSilentTimeSpan.SetWindowText(str);

	// obt@
	for ( int i = 0; i<BUF_NUM; i++ ) {
		 m_hInData[i]    = GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE, BUF_SIZE);
		m_lpInData[i]    = (LPSTR)GlobalLock(m_hInData[i]);

		 m_hInWaveHdr[i] = GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE, sizeof(WAVEHDR));
		m_lpInWaveHdr[i] = (LPWAVEHDR)GlobalLock(m_hInWaveHdr[i]);

		m_lpInWaveHdr[i]->lpData = m_lpInData[i];
		m_lpInWaveHdr[i]->dwBufferLength = BUF_SIZE;
		m_lpInWaveHdr[i]->dwFlags = 0;
		m_lpInWaveHdr[i]->dwLoops = 0;
	}

	while (1) { 
		MMRESULT mmresult = waveInOpen(&m_hwi,WAVE_MAPPER,&m_wfx,(DWORD)m_hWnd, 0,CALLBACK_WINDOW );
		if ( MMSYSERR_NOERROR != mmresult ) {
			int nMbResult;
	
			switch (mmresult) {
				case MMSYSERR_ALLOCATED:
				nMbResult=MessageBox("w肳ꂽ\[X͂łɊ蓖ĂĂ܂B","waveInOpen",MB_ABORTRETRYIGNORE);
				break;
			case MMSYSERR_BADDEVICEID:
				nMbResult=MessageBox("w肳ꂽfoCXʎq͔͈͊OłB","waveInOpen",MB_ABORTRETRYIGNORE);
				break;
			case MMSYSERR_NODRIVER:
				nMbResult=MessageBox("foCXhCo݂܂B","waveInOpen",MB_ABORTRETRYIGNORE);
				break;
			case MMSYSERR_NOMEM:
				nMbResult=MessageBox("蓖ĂȂA܂̓bNł܂B","waveInOpen",MB_ABORTRETRYIGNORE);
				break;
			case WAVERR_BADFORMAT:
				nMbResult=MessageBox("T|[gĂȂEF[utH[I[fBI`ŃI[v悤Ƃ܂B","waveInOpen",MB_ABORTRETRYIGNORE);
				break;
			default:
				nMbResult=MessageBox("m̃G[","waveInOpen",MB_ABORTRETRYIGNORE);
				break;
			}
			if ( nMbResult == IDABORT ) {
				m_bRecording = FALSE;
				PostMessage(WM_CLOSE);
				return FALSE;
			}
			else if ( nMbResult == IDIGNORE ) {
				break;
			}
			else // if ( nMbResult == IDRETRY  )
			{
				continue;
			}
		}
		else {
			break;
		}
	}

	for ( m_curNum = 0; m_curNum < BUF_NUM-2 ; m_curNum++ ) {
		waveInPrepareHeader( m_hwi, m_lpInWaveHdr[m_curNum],sizeof(WAVEHDR) );
		waveInAddBuffer( m_hwi, m_lpInWaveHdr[m_curNum],sizeof(WAVEHDR) );
	}

	waveInStart(m_hwi);

	if ( this->m_bTimerSetByIniFile ) {
		m_dtptStart.SetTime(&m_timerStart);
		m_dtpdStart.SetTime(&m_timerStart);
		CTimeSpan ts = m_timerEnd - m_timerStart;

		m_nStopHour = ts.GetHours();
		m_nStopMin  = ts.GetMinutes();
		
		CString str;
		str.Format("%d",m_nStopHour);
		m_edtStopHour.SetWindowText(str);
		str.Format("%d",m_nStopMin);
		m_edtStopMin.SetWindowText(str);
		
		m_CheckPowerdown.SetCheck(m_bCheckPowerdown?1:0);
	}
	else {
		// ʏ͎̐ɂȂ悤ɂB
		// 23̓oO(^^; ܂AB
		CTime t;
		if ( m_dtptStart.GetTime(t) == GDT_VALID ) {
			// Ԃ̌؂̂āB
			t = CTime(t.GetYear(),t.GetMonth(),t.GetDay(),t.GetHour(),0,0);
			CTimeSpan ts = CTimeSpan( 0, 1, 0, 0);
			// CTime t Ƃ +1 hour ĂǁAJオ菈ʓ|B
			t += ts;	// PԑB
			m_dtptStart.SetTime(&t);
		}
		m_nTimerStatus = 0;
	}


// initialize the threads and let them start running!
/*
	m_pMp3Thread = AfxBeginThread(Mp3ThreadProc, this, THREAD_PRIORITY_NORMAL,
			0, CREATE_SUSPENDED);
	m_pMp3Thread->ResumeThread();
*/
	m_pMp3Thread = AfxBeginThread(Mp3ThreadProc, this, m_nThreadPriority, 0, 0);

	if ( this->m_bTimerSetByIniFile ) {
		// ^C}{^ƂɂB
		OnBtnTimer();
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CSRecDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;

		CSRecApp* pApp = (CSRecApp*)AfxGetApp();
		dlgAbout.m_strGogo = pApp->m_strGogoVer;

		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CSRecDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CSRecDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSRecDlg::LowAudioClose() 
{
	if ( m_hwi != 0 ) {
		if ( MMSYSERR_NOERROR != waveInStop(m_hwi)  ) MessageBox("waveInStop error");
		if ( MMSYSERR_NOERROR != waveInReset(m_hwi) ) MessageBox("waveInReset error");
		for ( int i = 0; i<BUF_NUM; i++ ) {
			if ( MMSYSERR_NOERROR != waveInUnprepareHeader( m_hwi, m_lpInWaveHdr[i],sizeof(WAVEHDR) )) MessageBox("waveInUnprepareHeader error");
			GlobalUnlock(m_hInWaveHdr[i]);
			GlobalFree(m_hInWaveHdr[i]);
			GlobalUnlock(m_hInData[i]);
			GlobalFree(m_hInData[i]);
		}	
		if ( MMSYSERR_NOERROR != waveInClose(m_hwi) ) MessageBox("waveInClose error");
		m_hwi = 0;
	}
}

BOOL CSRecDlg::DestroyWindow() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ

	LowAudioClose();

	if ( m_fp != FALSE ) {
		WavFileClose();
	}

	// INI t@CoB
	WriteIni();

	if ( m_fpDebugLog != NULL ) {
		fprintf(m_fpDebugLog,"end logging...\n\n");
		fclose(m_fpDebugLog);
	}

	// Xbh̏I҂BAȂĂvƎvǁB
	// Ȃ݂ɁAOnClose() ŏI悤ɂĂ܂B
	DWORD ExitCode;
	int nCount = 0;
	do {
		GetExitCodeThread(m_pMp3Thread,&ExitCode);
		nCount ++;
		Sleep(1000);
	} while ( (ExitCode == STILL_ACTIVE) && (nCount < 5) );

	return CDialog::DestroyWindow();
}

void CSRecDlg::WavFileOpen()
{
	m_fileNum++;

	if ( m_strFld.Right(1).Compare("\\") ==0 ) 
	{
		m_strFld = m_strFld.Left(m_strFld.GetLength()-1);
		m_editFld.SetWindowText(m_strFld);
	}

	m_strFilename.Format("%s\\%s%03d.wav", m_strFld, m_strFilepre, m_fileNum);

	if ( m_bSkip == false ) {
		m_editFileName.SetWindowText(m_strFilename);
	}

	m_dwPeak = 0;
	m_nTimestamp = CTime::GetCurrentTime().GetTime();	// ݎ

	m_fp = fopen(m_strFilename,"wb");

	if ( m_fp == NULL ) {
		OnStop();
		MessageBox("t@CJ܂","ERROR",MB_ICONINFORMATION);
		return;
	}

	fwrite("RIFF\0\0\0\0WAVEfmt \x10\0\0\0",0x14,1,m_fp);
	fwrite(&m_wfx,sizeof(m_wfx)-2,1,m_fp);
	fwrite("data\0\0\0\0",4,2,m_fp);

	m_waveLen = 0;

	// Ȃ̓ɖB
	// ̈R[hȂ(^^;
	DWORD dw = 0;
	for(DWORD i=0; i<m_nPriGapLen ; i++) {
		fwrite(&dw,1,4,m_fp);
	}
	m_waveLen += m_nPriGapLen * 4;
}

void CSRecDlg::WavFileClose()
{
	if ( m_fp != NULL ) {
		// Ȃ̌ɖB
		// ̈R[hȂ(^^;
		DWORD dw = 0;
		for(DWORD i=0; i<m_nPostGapLen ; i++) {
			fwrite(&dw,1,4,m_fp);
		}
		m_waveLen += m_nPostGapLen * 4;

		fseek(m_fp,4,SEEK_SET);
		unsigned long a;
		a = m_waveLen+36;
		fwrite(&a,4,1,m_fp);
		fseek(m_fp,0x28,SEEK_SET);
		fwrite(&m_waveLen,4,1,m_fp);
	
		fclose(m_fp);
		m_fp = NULL;

		//if ( m_bCheckMp3 ) {
		if ( m_waveLen != m_nPriGapLen * 4 + m_nPostGapLen * 4 && m_bSkip == false ) {
			// t@Cɘ^Ă
			int nCount;
			CSingleLock sLock(&(m_Mutex));
			sLock.Lock();
			{
				m_strAryWavFilename.Add(m_strFilename);
				m_uintAryWavPeak.Add(m_dwPeak);
				m_uintAryTimestamp.Add(m_nTimestamp);
				nCount = m_strAryWavFilename.GetSize();
					
				CString strCount;
				strCount.Format("%d",nCount);
				g_pSRecDlg->m_editMp3Countdown.SetWindowText(strCount);
			}
			sLock.Unlock();

			if ( m_fpDebugLog != NULL && (m_nDebugLogLevel&1)==1 ) {
				fprintf(m_fpDebugLog,"%s  peak = %d\n",m_strFilename,m_dwPeak);
			}

			if ( nCount == 1 ) {
				m_Event.PulseEvent();
			}
		}
		else {
			// u^ꂸɕꂽAB
			remove(m_strFilename);
		}

		if ( m_bSkip == true ) {
			m_bSkip = false;
			m_BtnSkip.EnableWindow(TRUE);

			// t@C̔ԍ̂܂킹邽߂Ƀ}CiXPB
			// 炵R[hȂB
			m_fileNum--;
		}
	}
}

void CSRecDlg::OnRec() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( m_bRecording == TRUE ) return;

	if ( ! (m_bCheckWav||m_bCheckMp3||m_bCheckWma) ) {
		MessageBox("WAV  ߌ  QCcƐS ̂ЂƂ͑IĂ");
		return;
	}

	m_bRecording = TRUE;

	if ( m_bSkip == false ) {
		m_editRecStatus.SetWindowText(_T("^҂"));
	}
	m_nTimerStatus = 0;	// {^ꂽƂ́Au^C}œ삵ĂȂBvƂB
						// ^C}Ă΂ꂽƂ͂̂ƐlȂႢ܂B

	WavFileOpen();
}

void CSRecDlg::OnStop() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	if ( m_bRecording == FALSE ) return;
	m_bRecording = FALSE;

	WavFileClose();

	m_nSilent = 2;	// L͕s
}

void CSRecDlg::OnBtnRef() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog fDlg(FALSE,NULL,m_strFilepre,OFN_HIDEREADONLY);
	fDlg.m_ofn.lpstrTitle = _T("WAVEt@CvtBbNXw");
	fDlg.m_ofn.lpstrInitialDir = m_strFld;
	if ( fDlg.DoModal() != IDOK ) return;

	m_strFld = fDlg.GetPathName();

	if ( m_strFld != m_strFld.Left(m_strFld.ReverseFind ('\\')) ){
		m_strFld = m_strFld.Left(m_strFld.ReverseFind ('\\'));
		m_fileNum = 0;
	}
	if ( m_strFilepre = fDlg.GetFileTitle() ){
		m_strFilepre = fDlg.GetFileTitle();
		m_fileNum = 0;
	}

	m_editFld.SetWindowText( m_strFld );
	m_editFilepre.SetWindowText( m_strFilepre );

	if ( !fDlg.GetFileExt().IsEmpty() ) {
		MessageBox(_T("gq͎w肵Ă܂B߂ȂB"),_T("]vȂb_CAO"),MB_ICONINFORMATION);
	}
}

void CSRecDlg::OnChangeEditFilepre() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt EM_SETEVENTMASK
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_editFilepre.GetWindowText( m_strFilepre );
}

void CSRecDlg::OnChangeEditFld() 
{
	m_editFld.GetWindowText( m_strFld );
}

LRESULT CSRecDlg::OnMmWinData(WPARAM wParam, LPARAM lParam)
{
	// ^ 1024TvƂɂ郁bZ[WB
	// ̃\tg̊̂łˁB

	// df̎AȂĂ΂邱Ƃ̂ŉ
	if ( m_hwi == 0 ) return 0;

	int i,j;

	static bool flagP = false;

	static COMPLEX pcFreqL[FFT_SIZE];
	static COMPLEX pcFreqR[FFT_SIZE];
	static short psFreqL[FFT_SIZE/2];
	static short psFreqR[FFT_SIZE/2];

	// ߌ㉻ɔo
	//WAVEHDR* pWavehdr = (WAVEHDR*)lParam;
	m_pWavehdr = (WAVEHDR*)lParam;

	waveInUnprepareHeader(m_hwi, m_pWavehdr, sizeof(WAVEHDR) );

	if ( ++m_curNum==BUF_NUM) m_curNum=0;
	waveInPrepareHeader( m_hwi, m_lpInWaveHdr[m_curNum],sizeof(WAVEHDR) );
	waveInAddBuffer( m_hwi, m_lpInWaveHdr[m_curNum],sizeof(WAVEHDR) );

	short* pStart = (short*)m_pWavehdr->lpData;
	short* pEnd   = (short*)(m_pWavehdr->lpData+BUF_SIZE);
	DWORD dwLevelL = 0;
	DWORD dwLevelR = 0;

	DWORD dwDispLevelL;	// \px L
	DWORD dwDispLevelR;	// \px R

	// x[^̂قɂ
	// `FbNŎĝŕKvZB
	// switch ̒ɓȂłˁB
	for ( short* p = pStart; p < pEnd ; p++ ) {
		dwLevelL = max(dwLevelL,(ULONG)abs(*p));
		p++;
		dwLevelR = max(dwLevelR,(ULONG)abs(*p));
	}

	if ( m_bCheckNormalize && m_nNormalizeLevel!=0 ) {
		// Kl\
		DWORD nMax = 32767*m_nNormalizeLevel;
		dwDispLevelL = dwLevelL*32767;
		if ( dwDispLevelL >  nMax ) dwDispLevelL =  nMax;
		//if ( dwDispLevelL < -nMax ) dwDispLevelL = -nMax;
		dwDispLevelL = ((dwDispLevelL/m_nNormalizeLevel)+255)/256;

		dwDispLevelR = dwLevelR*32767;
		if ( dwDispLevelR >  nMax ) dwDispLevelR =  nMax;
		//if ( dwDispLevelR < -nMax ) dwDispLevelR = -nMax;
		dwDispLevelR = ((dwDispLevelR/m_nNormalizeLevel)+255)/256;
	}
	else {
		dwDispLevelL = (dwLevelL+255)/256;
		dwDispLevelR = (dwLevelR+255)/256;
	}

	flagP = !flagP;

	if ( flagP ) {
		CDC* pDC = GetDC();
	
		switch (m_dispMode) {
		case 1:
			pDC->FillSolidRect(LX             ,LY,   dwDispLevelL,LH,0x0000FF00);
			pDC->FillSolidRect(LX+dwDispLevelL,LY,RW-dwDispLevelL,LH,0x00999999);
			pDC->FillSolidRect(RX             ,RY,   dwDispLevelR,RH,0x0000FF00);
			pDC->FillSolidRect(RX+dwDispLevelR,RY,RW-dwDispLevelR,RH,0x00999999);
			break;
		case 2:
			fft((short *)m_pWavehdr->lpData,pcFreqL,pcFreqR);
			for ( i=0;i<FFT_SIZE/2;i++) {
				//psFreqL[i]= log(sqrt(pcFreqL[i].real*pcFreqL[i].real + pcFreqL[i].imag*pcFreqL[i].imag)/1024)/log(1024)*32+32;
				psFreqL[i]= (short)(log(sqrt(pcFreqL[i].real*pcFreqL[i].real + pcFreqL[i].imag*pcFreqL[i].imag))*4.6166241308446829) /* 4.6132/log(1024) */;
				if      ( psFreqL[i] < 0   ) psFreqL[i]=0;
				else{
					psFreqL[i]*=2;
					if ( psFreqL[i] >= 32 ) psFreqL[i]=31;
				}
				//psFreqR[i]= log(sqrt(pcFreqR[i].real*pcFreqR[i].real + pcFreqR[i].imag*pcFreqR[i].imag)/1024)/log(1024)*32+32;
				psFreqR[i]= (short)(log(sqrt(pcFreqR[i].real*pcFreqR[i].real + pcFreqR[i].imag*pcFreqR[i].imag))*4.6166241308446829) /* 4.6132/log(1024) */;
				if      ( psFreqR[i] < 0   ) psFreqR[i]=0;
				else{
					psFreqR[i]*=2;
					if ( psFreqR[i] >= 32 ) psFreqR[i]=31;
				}
			}
	

			for ( i=j=0;j<FFT_SIZE/2;i++,j+=4) {
				int d;
				d = max( max(psFreqL[j],psFreqL[j+1]) , max(psFreqL[j+2],psFreqL[j+3]) );
				pDC->FillSolidRect(LX+i,LY     ,1,32-d,0x00999999);
				pDC->FillSolidRect(LX+i,LY+32-d,1,   d,0x0000FF00);
				d = max( max(psFreqR[j],psFreqR[j+1]) , max(psFreqR[j+2],psFreqR[j+3]) );
				pDC->FillSolidRect(RX+i,RY     ,1,32-d,0x00999999);
				pDC->FillSolidRect(RX+i,RY+32-d,1,   d,0x0000FF00);
			}
			break;
		}
		ReleaseDC(pDC);
	}

	m_dwCurLevel = max( dwLevelL, dwLevelR);

	if ( m_dwCurLevel <= m_dwEditThreshold ) {
		m_dwSilentCount++;
	}
	else {
		m_dwSilentCount = 0;
	}

	if ( ! m_bRecording ) {
		if ( m_dwEditSilentTimeSpan!=0 && m_dwEditSilentTimeSpan <= m_dwSilentCount ) {
			if ( m_nSilent != 0 && m_bSkip == false ) {
				m_editRecStatus.SetWindowText(_T("~ ()"));
			}
			m_nSilent = 0;
		}
		else {
			if ( m_nSilent != 1 && m_bSkip == false ) {
				m_editRecStatus.SetWindowText(_T("~ (L)"));
			}
			m_nSilent = 1;
		}
	}
	else {
		if ( m_dwEditSilentTimeSpan!=0 && m_dwEditSilentTimeSpan <= m_dwSilentCount ) {
			if ( m_waveLen != m_nPriGapLen * 4 ){
				m_editRecStatus.SetWindowText(_T("^҂"));
				WavFileClose();
				WavFileOpen();
			}
		}
		else{
			if ( m_waveLen == m_nPriGapLen * 4 && m_bSkip == false ) {
				m_editRecStatus.SetWindowText(_T("^"));	
			}
			
			m_waveLen += BUF_SIZE;
			m_dwPeak = max(m_dwPeak,m_dwCurLevel);
			if (m_fp!=NULL) {
				// WAV
				fwrite(m_pWavehdr->lpData,1,BUF_SIZE,m_fp);
				if ( ferror(m_fp) ) {
					OnStop();
				}
			}
		}
	}
	return 0;
}


void CSRecDlg::OnRadioSpectrum() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( ! m_bRecording ) {
		m_bIniModified = true;
		m_dispMode = 2;
	}
	else {
		DispModeCheck();
	}

	SamplingRateCheck();
}

void CSRecDlg::OnRadioLevel() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( ! m_bRecording ) {
		m_bIniModified = true;
		m_dispMode = 1;
	}
	else {
		DispModeCheck();
	}

	SamplingRateCheck();
}

void CSRecDlg::OnRadio32() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( ! m_bRecording ) {
		m_bIniModified = true;
		m_wfx.nSamplesPerSec = 32000;
		MessageBox(_T("SRecċNɗLɂȂ܂B\n߂ȂB"));
	}
	else {
		SamplingRateCheck();
	}

	DispModeCheck();
}

void CSRecDlg::OnRadio44() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( ! m_bRecording ) {
		m_bIniModified = true;
		m_wfx.nSamplesPerSec = 44100;
		MessageBox(_T("SRecċNɗLɂȂ܂B\n߂ȂB"));
	}
	else {
		SamplingRateCheck();
	}

	DispModeCheck();
}

void CSRecDlg::OnRadio48() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( ! m_bRecording ) {
		m_bIniModified = true;
		m_wfx.nSamplesPerSec = 48000;
		MessageBox(_T("SRecċNɗLɂȂ܂B\n߂ȂB"));
	}
	else {
		SamplingRateCheck();
	}

	DispModeCheck();
}

// WI{^\ɔf
void CSRecDlg::DispModeCheck()
{
	if ( m_dispMode == 1 ) {
		CheckDlgButton(IDC_RADIO_LEVEL,1);
		CheckDlgButton(IDC_RADIO_SPECTRUM,0);
	}
	else {
		CheckDlgButton(IDC_RADIO_LEVEL,0);
		CheckDlgButton(IDC_RADIO_SPECTRUM,1);
	}
}

// WI{^\ɔf
void CSRecDlg::SamplingRateCheck()
{
	switch ( m_wfx.nSamplesPerSec ) {
	case 32000:
		CheckDlgButton(IDC_RADIO_32,1);
		CheckDlgButton(IDC_RADIO_44,0);
		CheckDlgButton(IDC_RADIO_48,0);
		break;
	case 44100:
		CheckDlgButton(IDC_RADIO_32,0);
		CheckDlgButton(IDC_RADIO_44,1);
		CheckDlgButton(IDC_RADIO_48,0);
		break;
	case 48000:
		CheckDlgButton(IDC_RADIO_32,0);
		CheckDlgButton(IDC_RADIO_44,0);
		CheckDlgButton(IDC_RADIO_48,1);
	}
}

void CSRecDlg::OnCheckMp3() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// WAV Ƀ`FbNĂȂ΁AȂ
	// (ꂿ።)
	/*
	if ( m_bCheckWav == false ) {
		m_CheckMp3.SetCheck(1);
		return;
	}
	*/

	if ( m_bRecording ) {
		m_CheckMp3.SetCheck(m_CheckMp3.GetCheck()?0:1);
	}
	m_bCheckMp3 = m_CheckMp3.GetCheck()!=0;
}

void CSRecDlg::OnCheckWma() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// WAV Ƀ`FbNĂȂ΁AȂ
	// (ꂿ።)
	/*
	if ( m_bCheckWav == false ) {
		m_CheckWma.SetCheck(1);
		return;
	}
	*/

	if ( m_bRecording ) {
		m_CheckWma.SetCheck(m_CheckWma.GetCheck()?0:1);
	}
	m_bCheckWma = m_CheckWma.GetCheck()!=0;
}

void CSRecDlg::OnCheckWav() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// MP3 Ƀ`FbNĂȂ΁AȂ
	// (ꂿ።)
	/*
	if ( m_bCheckMp3 == false ) {
		m_CheckWav.SetCheck(1);
		return;
	}
	*/

	if ( m_bRecording ) {
		m_CheckWav.SetCheck(m_CheckWav.GetCheck()?0:1);
	}
	m_bCheckWav = m_CheckWav.GetCheck()!=0;
}

void CSRecDlg::OnCheckNormalize() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_bCheckNormalize = m_CheckNormalize.GetCheck()!=0;
}

void CSRecDlg::OnBtnThreshold() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_dwEditThreshold = m_dwCurLevel + (m_dwCurLevel+9)/10;	// P
	CString str;
	str.Format("%d",m_dwEditThreshold);
	m_editThreshold.SetWindowText(str);
}

void CSRecDlg::OnKillfocusEditThreshold() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString str;
	m_editThreshold.GetWindowText(str);
	m_dwEditThreshold = atol(str);
}

void CSRecDlg::OnKillfocusEditSilentTimeSpan() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString str;
	m_editSilentTimeSpan.GetWindowText(str);
	m_dwEditSilentTimeSpan = atol(str);
}

void CSRecDlg::OnCheck4844() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_bCheck4844 = m_Check4844.GetCheck()!=0;
}

void CSRecDlg::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if ( m_bRecording ) {
		MessageBox("^͏Ił܂");
		return;
	}

	int nCount;
	CSingleLock sLock(&(m_Mutex));
	sLock.Lock();
	{
		nCount = m_strAryWavFilename.GetSize();
	}
	sLock.Unlock();

	if ( nCount != 0 ) {
		MessageBox("ϊ͏Ił܂");
		return;
	}

	// XbhI点
	m_Event.PulseEvent();
	
	CDialog::OnClose();
}

void CSRecDlg::OnBtnGogoconf() 
{
	DWORD dwAryBitRate[]={32,40,48,56,64,80,96,112,128,160,192,224,256,320};
	DWORD dwAryOutFreq[]={16000, 22050, 24000, 32000, 44100, 48000};
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	if ( m_bRecording ) return;
	
	CGogoConfDlg gogoDlg;

	gogoDlg.m_bUsepsy        = m_GogoSetting.dwUsePsy?1:0;
	gogoDlg.m_bUseLpf16      = m_GogoSetting.dwUseLpf16?1:0;
	gogoDlg.m_bVbr     = m_GogoSetting.bVbr;
	gogoDlg.m_nCmbVbr  = m_GogoSetting.dwVbr;
	gogoDlg.m_bOutFreq = m_GogoSetting.bOutFreq;
	gogoDlg.m_nOutFreq = m_GogoSetting.dwOutFreq;

	switch ( m_GogoSetting.dwBitRate ) {
	case 32:
		gogoDlg.m_nCmbBitrate    = 0;
		break;
	case 40:
		gogoDlg.m_nCmbBitrate    = 1;
		break;
	case 48:
		gogoDlg.m_nCmbBitrate    = 2;
		break;
	case 56:
		gogoDlg.m_nCmbBitrate    = 3;
		break;
	case 64:
		gogoDlg.m_nCmbBitrate    = 4;
		break;
	case 80:
		gogoDlg.m_nCmbBitrate    = 5;
		break;
	case 96:
		gogoDlg.m_nCmbBitrate    = 6;
		break;
	case 112:
		gogoDlg.m_nCmbBitrate    = 7;
		break;
	case 128:
		gogoDlg.m_nCmbBitrate    = 8;
		break;
	case 160:
		gogoDlg.m_nCmbBitrate    = 9;
		break;
	case 192:
		gogoDlg.m_nCmbBitrate    = 10;
		break;
	case 224:
		gogoDlg.m_nCmbBitrate    = 11;
		break;
	case 256:
		gogoDlg.m_nCmbBitrate    = 12;
		break;
	case 320:
		gogoDlg.m_nCmbBitrate    = 13;
		break;
	default:
		gogoDlg.m_nCmbBitrate    = 8;
	}
	gogoDlg.m_nCmbEmhasis    = m_GogoSetting.dwEmphasis;
	gogoDlg.m_nCmbEncodemode = m_GogoSetting.dwEncodeMode;

	switch ( m_GogoSetting.dwBitRate ) {
	case 16000:
		gogoDlg.m_nOutFreq = 0;
		break;
	case 22050:
		gogoDlg.m_nOutFreq = 1;
		break;
	case 24000:
		gogoDlg.m_nOutFreq = 2;
		break;
	case 32000:
		gogoDlg.m_nOutFreq = 3;
		break;
	case 44100:
		gogoDlg.m_nOutFreq = 4;
		break;
	case 48000:
		gogoDlg.m_nOutFreq = 5;
		break;
	default:
		gogoDlg.m_nOutFreq = 4;
	}

	if ( gogoDlg.DoModal() == IDOK ) {
		m_bIniModified = true;
		m_GogoSetting.dwUsePsy     = gogoDlg.m_bUsepsy;
		m_GogoSetting.dwUseLpf16   = gogoDlg.m_bUseLpf16;
		m_GogoSetting.bVbr         = gogoDlg.m_bVbr;
		m_GogoSetting.dwVbr        = gogoDlg.m_nCmbVbr;
		m_GogoSetting.dwBitRate    = dwAryBitRate[gogoDlg.m_nCmbBitrate];
		m_GogoSetting.dwEmphasis   = gogoDlg.m_nCmbEmhasis;
		m_GogoSetting.dwEncodeMode = gogoDlg.m_nCmbEncodemode;
		m_GogoSetting.bOutFreq     = gogoDlg.m_bOutFreq;
		m_GogoSetting.dwOutFreq    = dwAryOutFreq[gogoDlg.m_nOutFreq];
	}
}

void CSRecDlg::OnBtnSkip() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_bSkip = true;
	m_BtnSkip.EnableWindow(FALSE);
	m_editRecStatus.SetWindowText(_T("XLbv"));
	m_editFileName.SetWindowText(_T("XLbv"));
}

void CSRecDlg::OnBtnTimer() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	if ( m_nTimer == 0 ) {
		// ^C}쒆łȂ΃X^[g
		CTime timeDate;
		CTime timeTime;
		CTimeSpan timeTimes;

		if ( m_CheckStartnow.GetCheck()==0 ) {
			// uvOFF
			if ( m_dtpdStart.GetTime(timeDate) != GDT_VALID ) {
				MessageBox("Jntݒ肳Ă܂");
				return;
			}
			if ( m_dtptStart.GetTime(timeTime) != GDT_VALID ) {
				MessageBox("Jnݒ肳Ă܂");
				return;
			}
			m_timerStart  =CTime(timeDate.GetYear(),timeDate.GetMonth(),timeDate.GetDay(),timeTime.GetHour(),timeTime.GetMinute(),timeTime.GetSecond());
			CTimeSpan ts = CTimeSpan( 0, 0, 0, 1);
			m_timerStart -= ts;	// 1bĂ
		}
		else {
			// uvON
			m_timerStart  = CTime::GetCurrentTime();	// I
			CTimeSpan ts = CTimeSpan( 0, 0, 0, 1);
			m_timerStart -= ts;	// 1bĂ
		}

		CString str;
		int nTimerDiff;
		m_edtStopHour.GetWindowText(str);
		nTimerDiff  = atoi(str);
		nTimerDiff *= 60;
		this->m_edtStopMin.GetWindowText(str);
		nTimerDiff += atoi(str);
		nTimerDiff *= 60;

		if ( nTimerDiff == 0 ) {
			MessageBox("^Ԃ0błEEEB");
			return;
		}

		nTimerDiff += 2;	// 傢߂ɁB

		m_timerEnd = m_timerStart + nTimerDiff;

		CTime tCur = CTime::GetCurrentTime();

		if ( m_timerEnd <= tCur ) {
			MessageBox("Jn͂납AI߂Ă܂Ă܂B","woops");
			return;
		}

		m_nTimer = this->SetTimer(1,200,NULL);
		if ( m_nTimer == 0 ) {
			MessageBox("^C}擾ł܂(ȂH)");
			return;
		}
		m_nTimerStatus = 1;
		m_BtnTimer.SetWindowText(_T(""));

		if ( m_timerStart <= tCur ) {
			if ( ! m_bRecording ) {
				OnRec();
			}
			m_nTimerStatus = 2;
		}
	}
	else {
		// ^C}쒆ł΃^C}Xgbv
		KillTimer(1);
		m_nTimer = 0;
		m_nTimerStatus = 0;
		m_BtnTimer.SetWindowText(_T("ZbgI"));
		SetTimerStatusText("---");
	}
}

void CSRecDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	switch (nIDEvent ) {
	case 1:
		if ( m_nTimer != 0 ) {
			CTime tCur = CTime::GetCurrentTime();
			if ( m_nTimerStatus == 1 ) {
				// Jn҂
				CTimeSpan ts = m_timerStart - tCur;
				CString str = ts.Format("Jn܂ %H:%M:%S");
				SetTimerStatusText(str);
				if ( tCur > m_timerStart ) {
					// JnI
					OnRec();
					m_nTimerStatus = 2;
				}
			}
			else if ( m_nTimerStatus == 2 ) {
				// ~҂
				CTimeSpan ts = m_timerEnd - tCur;
				CString str = ts.Format("~܂ %H:%M:%S");
				SetTimerStatusText(str);
				if ( tCur > m_timerEnd ) {
					// ~I
					OnStop();
					KillTimer(1);
					m_nTimer = 0;
					m_nTimerStatus = 3;

					m_BtnTimer.SetWindowText(_T("ZbgI"));
					SetTimerStatusText("---");
				}
			}
		}

		break;
	default:
		CDialog::OnTimer(nIDEvent);
	}
}

void CSRecDlg::SetTimerStatusText(CString str) 
{
	static CString strBefore;
	if ( strBefore.Compare(str) != 0 ) {
		m_edtTimerStat.SetWindowText(str);
		strBefore = str;
	}
}

void CSRecDlg::OnCheckTimestamp() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_bCheckTimestamp = m_CheckTimestamp.GetCheck()!=0;
}

void CSRecDlg::OnCheckStartnow() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( m_CheckStartnow.GetCheck()!=0 ) {
		m_dtpdStart.EnableWindow(FALSE);
		m_dtptStart.EnableWindow(FALSE);
	}
	else {
		m_dtpdStart.EnableWindow(TRUE);
		m_dtptStart.EnableWindow(TRUE);
	}
}

void CSRecDlg::OnCheckPowerdown() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_bCheckPowerdown = m_CheckPowerdown.GetCheck()!=0;
	if ( m_bCheckPowerdown ) {
		MessageBox("Ƃ肠AE`Win98ł͓ǂA\n܂sȋ@\܂B");
	}
}

BOOL CSRecDlg::OnQueryEndSession()
{
	if ( m_bRecording ) {
		// ^͏Ił܂
		return FALSE;	// Ił܂B
	}

	int nCount;
	CSingleLock sLock(&(m_Mutex));
	sLock.Lock();
	{
		nCount = m_strAryWavFilename.GetSize();
	}
	sLock.Unlock();

	if ( nCount != 0 ) {
		// ϊ͏Ił܂
		return FALSE;	// Ił܂B
	}

	return TRUE;	// Ił܂B
}

LRESULT CSRecDlg::OnMp3ThreadEnd(WPARAM wParam, LPARAM lParam)
{
	// dfONAXbhIɂ̊֐ Post B

	// WAVẼobt@̂|͓XbhsȂ΂ȂȂ炵B
	g_pSRecDlg->LowAudioClose();

	Sleep(3000);	// ƂȂ

	// ver 0.57 uL]킳d؂v
	//::ExitWindowsEx(EWX_SHUTDOWN,0);	// I
	::ExitWindowsEx(EWX_SHUTDOWN | EWX_FORCE ,0);	// I
	return 0;
}


void CSRecDlg::OnBtnAbout() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CAboutDlg dlgAbout;

	CSRecApp* pApp = (CSRecApp*)AfxGetApp();
	dlgAbout.m_strGogo = pApp->m_strGogoVer;

	dlgAbout.DoModal();
}
