/* -*- TABSIZE = 4 -*- */
/*
 *	for new GOGO-no-coda (1999/09,10)
 *	Copyright (C) 1999 PEN@MarineCat
 */
#ifndef __MUSUI_H__
#define __MUSUI_H__

#include <limits.h>

typedef	signed int					MERET;
typedef	unsigned long				MPARAM;
typedef	unsigned long				UPARAM;

#ifdef GOGO_DLL_EXPORTS
#define		EXPORT					__declspec(dllexport) 
#else
#define		EXPORT					
#endif


#define	ME_NOERR					(0)		// I
#define	ME_EMPTYSTREAM				(1)		// Xg[ŌɒB
#define	ME_HALTED					(2)		// ([U[̎ɂ)fꂽ
#define	ME_INTERNALERROR			(10)	// G[
#define	ME_PARAMERROR				(11)	// ݒŃp[^[G[
#define	ME_NOFPU					(12)	// FPU𑕒ĂȂ!!
#define	ME_INFILE_NOFOUND			(13)	// ̓t@C𐳂JȂ
#define	ME_OUTFILE_NOFOUND			(14)	// o̓t@C𐳂JȂ
#define	ME_FREQERROR				(15)	// o͎gȂ
#define	ME_BITRATEERROR				(16)	// o̓rbg[gȂ
#define	ME_WAVETYPE_ERR				(17)	// EF[u^CvȂ
#define	ME_CANNOT_SEEK				(18)	// V[NoȂ
#define	ME_BITRATE_ERR				(19)	// rbg[gݒ肪Ȃ
#define	ME_BADMODEORLAYER			(20)	// [hEC̐ݒُ
#define	ME_NOMEMORY					(21)	// A[P[Vs
#define	ME_CANNOT_SET_SCOPE			(22)	// XbhG[(pthread only)
#define	ME_CANNOT_CREATE_THREAD		(23)	// XbhG[
#define	ME_WRITEERROR				(24)	// L}̗̂eʕs


// [U[̃R[obN֐`
typedef	MERET	(*MPGE_USERFUNC)(void *buf, unsigned long nLength );
#define MPGE_NULL_FUNC (MPGE_USERFUNC)NULL	// for HighC

///////////////////////////////////////////////////////////////////////////
// ݒp
///////////////////////////////////////////////////////////////////////////
// ̓t@Cݒ ()
#define		MC_INPUTFILE			(1)
// para1 ̓foCX̑I
	#define		MC_INPDEV_FILE		(0)		// ̓foCX̓t@C
	#define		MC_INPDEV_STDIO		(1)		// ̓foCX͕W
	#define		MC_INPDEV_USERFUNC	(2)		// ̓foCX̓[U[`
	// para2 (Kvł)t@CB|C^w肷
	// GR[h͈̎ȉ̍\̂̃|C^w肷.
	struct MCP_INPDEV_USERFUNC {
		MPGE_USERFUNC	pUserFunc;		// R[obNΏۂ̃[U[֐B`MPGE_NULL_FUNCB
		unsigned int	nSize;			// t@CTCYBs̎ MC_INPDEV_MEMORY_NOSIZEwB
		int				nBit;			// PCMrbg[xwBnBit = 8 or 16
		int				nFreq;			// ͎g̎w(HzPʂ, 0<nChn)
		int				nChn;			// `lBnChn = 1 or 2
	};
	#define		MC_INPDEV_MEMORY_NOSIZE		(UINT_MAX)	// TCYs̎͂nSizeɓ

///////////////////////////////////////////////////////////////////////////
// o̓t@Cݒ (stdoutT|[g)
#define		MC_OUTPUTFILE			(2)
// para1 o̓foCXݒ
	#define		MC_OUTDEV_FILE		(0)		// o̓foCX̓t@C
	#define		MC_OUTDEV_STDOUT	(1)		// o̓foCX͕Wo
	#define		MC_OUTDEV_USERFUNC	(2)		// o̓foCX̓[U[`
// para2 (Kvł)t@CB|C^w

///////////////////////////////////////////////////////////////////////////
// GR[h^Cv
#define		MC_ENCODEMODE			(3)
// para1 [hݒ
	#define		MC_MODE_MONO		(0)		// m
	#define		MC_MODE_STEREO		(1)		// XeI
	#define		MC_MODE_JOINT		(2)		// WCg
	#define		MC_MODE_MSSTEREO	(3)		// ~bhTCh
	#define		MC_MODE_DUALCHANNEL	(4)		// fA`l

///////////////////////////////////////////////////////////////////////////
// rbg[gݒ
#define		MC_BITRATE				(4)
// para1 rbg[g lw


///////////////////////////////////////////////////////////////////////////
// ͂ŗpTvg̋w
#define		MC_INPFREQ				(5)
// para1 o͂ŗpf[^

///////////////////////////////////////////////////////////////////////////
// o͂ŗpTvg̋w
#define		MC_OUTFREQ				(6)
// para1 o͂ŗpf[^

///////////////////////////////////////////////////////////////////////////
// GR[hJnʒűw(wb_𖳎鎞)
#define		MC_STARTOFFSET			(7)

///////////////////////////////////////////////////////////////////////////
// S ON/OFF
#define		MC_USEPSY				(8)
// PARA1 BOOLl(TRUE/FALSE)

///////////////////////////////////////////////////////////////////////////
// 16KHzшtB^ ON/OFF
#define		MC_USELPF16				(9)
// PARA1 BOOLl(TRUE/FALSE)

///////////////////////////////////////////////////////////////////////////
// jbgw para1:BOOLl
#define		MC_USEMMX				(10)		// MMX@\̎gpݒ
#define		MC_USE3DNOW				(11)		// 3DNow!@\̎gpݒ
#define		MC_USEKNI				(12)		// KNI@\̎gpݒ
#define		MC_USEE3DNOW			(13)		// Extend 3D Now!@\̎gpݒ
#define		MC_USESPC1				(14)	// XCb`gpݒ
#define		MC_USESPC2				(15)	// XCb`gpݒ

///////////////////////////////////////////////////////////////////////////
// t@C^Ot
#define		MC_ADDTAG				(16)
// dwPara1  ^O  
// dwPara2 ^Of[^̃|C^

///////////////////////////////////////////////////////////////////////////
// Gt@VX^Cv̐ݒ
#define		MC_EMPHASIS				(17)	
// para1 Gt@VX^Cv̐ݒ
	#define		MC_EMP_NONE			(0)		// Gt@VXȂ(dflt)
	#define		MC_EMP_5015MS		(1)		// Gt@VX50/15ms
	#define		MC_EMP_CCITT		(3)		// Gt@VXCCITT

///////////////////////////////////////////////////////////////////////////
// VBR^Cv̐ݒ
#define		MC_VBR				(18)

///////////////////////////////////////////////////////////////////////////
// SMP support para1: interger
//#if	defined(USE_PTHREAD) || defined(USE_BTHREAD) || defined(USE_WINTHREAD)
#define		MC_CPU					(19)
//#endif

///////////////////////////////////////////////////////////////////////////
// ȉ4RAW-PCM̐ݒ̂
// PCM͎low, high bit ϊ
#define		MC_BYTE_SWAP		(20)

///////////////////////////////////////////////////////////////////////////
// 8bit PCM ͎
#define		MC_8BIT_PCM			(21)

///////////////////////////////////////////////////////////////////////////
// mono PCM ͎
#define		MC_MONO_PCM			(22)

///////////////////////////////////////////////////////////////////////////
// Towns SND ͎
#define		MC_TOWNS_SND		(23)

MERET	EXPORT	MPGE_initializeWork();
MERET	EXPORT	MPGE_setConfigure(MPARAM mode, UPARAM dwPara1, UPARAM dwPara2 );
MERET	EXPORT	MPGE_getConfigure(MPARAM mode, void *para1 );
MERET	EXPORT	MPGE_detectConfigure();
#ifdef USE_BETHREAD
MERET	EXPORT	MPGE_processFrame(int *frameNum);
#else
MERET	EXPORT	MPGE_processFrame();
#endif
MERET	EXPORT	MPGE_closeCoder();
MERET	EXPORT	MPGE_endCoder();
MERET	EXPORT	MPGE_getUnitStates( unsigned long *unit );

// ̃t@NVDLLo[ŴݗL
MERET	EXPORT	MPGE_getVersion( unsigned long *vercode,  char *verstring );
// vercode = 0x125 ->  version 1.25
// verstring       ->  "ver 1.25 1999/09/25" (260byteȏ̗̈pӂ邱)



////////////////////////////////////////////////////////////////////////////
// ݒ擾p
////////////////////////////////////////////////////////////////////////////
// 
#define		MG_INPUTFILE			(1)			// ̓t@C擾
#define		MG_OUTPUTFILE			(2)			// o̓t@C擾
#define		MG_ENCODEMODE			(3)			// GR[h[h
#define		MG_BITRATE				(4)			// rbg[g
#define		MG_INPFREQ				(5)			// ͎g
#define		MG_OUTFREQ				(6)			// o͎g
#define		MG_STARTOFFSET			(7)			// X^[gItZbg()
#define		MG_USEPSY				(8)			// S͂gp/Ȃ
#define		MG_USEMMX				(9)			// MMX@\̎gpݒ
#define		MG_USE3DNOW				(10)			// 3DNow!@\̎gpݒ
#define		MG_USEKNI				(11)		// KNI@\̎gpݒ
#define		MG_USEE3DNOW			(12)		// Extend 3DNow!@\̎gpݒ

#define		MG_USESPC1				(13)		// XCb`gpݒ
#define		MG_USESPC2				(14)		// XCb`gpݒ
#define		MG_COUNT_FRAME			(15)		// Ŝ̃t[擾
#define		MG_NUM_OF_SAMPLES		(16)		// 1t[̃Tv
#define		MG_MPEG_VERSION			(17)		//MPEG VERSION擾

#endif /* __MUSUI_H__ */
