// SRecDlg.h : wb_[ t@C
//

#if !defined(AFX_SRECDLG_H__B240D0F7_54E2_11D2_86C6_00A0C925E3DC__INCLUDED_)
#define AFX_SRECDLG_H__B240D0F7_54E2_11D2_86C6_00A0C925E3DC__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "mmsystem.h"

#define BUF_SIZE 8192
#define BUF_NUM 64

#define WM_MP3THREADEND (WM_USER + 1)

struct SGogoSetting
{
	DWORD dwEncodeMode;// GR[h[h MC_MODE_ MONO,STEREO,JOINT,MSSTEREO,DUALCHANNEL
	DWORD dwBitRate;	// rbg[g     32,40,48,56,64,80,96,112,128,160,192,224,256,320 
	DWORD dwUsePsy;	// S         FALSE( or 0 ),
	DWORD dwUseLpf16;	// [pXtB^ TRUE( or !0 ), 
	DWORD dwEmphasis;	// Gt@VX     MC_EMP_NONE MC_EMP_5015MS MC_EMP_CCITT
	DWORD bVbr;			// σrbg[g
	DWORD dwVbr;		// σrbg[g 0-9
	DWORD bOutFreq;		// o̓TvOg
	DWORD dwOutFreq;	// o̓TvOg 16000 22050 24000 32000 44100 48000
};

/////////////////////////////////////////////////////////////////////////////
// CSRecDlg dialog

class CSRecDlg : public CDialog
{
// \z
public:
	CSRecDlg(CWnd* pParent = NULL);	// W̃RXgN^

// Dialog Data
	//{{AFX_DATA(CSRecDlg)
	enum { IDD = IDD_SREC_DIALOG };
	CButton	m_CheckWma;
	CEdit	m_editSilentTimeSpan;
	CButton	m_CheckStartnow;
	CButton	m_CheckPowerdown;
	CButton	m_CheckTimestamp;
	CEdit	m_edtTimerStat;
	CDateTimeCtrl	m_dtpdStart;
	CButton	m_BtnTimer;
	CDateTimeCtrl	m_dtptStart;
	CEdit	m_edtStopMin;
	CEdit	m_edtStopHour;
	CButton	m_BtnSkip;
	CButton	m_BtnGogoInf;
	CProgressCtrl	m_prgrNormalize;
	CProgressCtrl	m_prgr4844;
	CButton	m_Check4844;
	CButton	m_CheckNormalize;
	CEdit	m_editMp3Countdown;
	CProgressCtrl	m_prgrMp3;
	CEdit	m_editThreshold;
	CButton	m_CheckWav;
	CButton	m_CheckMp3;
	CEdit	m_editFld;
	CEdit	m_editFilepre;
	CEdit	m_editRecStatus;
	CEdit	m_editFileName;
	DWORD	m_dwEditThreshold;
	UINT	m_nStopHour;
	UINT	m_nStopMin;
	DWORD	m_dwEditSilentTimeSpan;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CSRecDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Ƃт[
public:

// ჌x WAVE ̈̂߂̕ϐ -->
	// CQoł TRY! PC 1997/09 p.85` QlɂB
	//  C++ Builder ̋LB@TCP ŉ]悤ƂbB
	HWAVEIN m_hwi;
	WAVEFORMATEX m_wfx;

	HANDLE m_hInData[BUF_NUM];
	HANDLE m_hInWaveHdr[BUF_NUM];
	LPSTR  m_lpInData[BUF_NUM];
	LPWAVEHDR m_lpInWaveHdr[BUF_NUM];
// ჌x WAVE ̈̂߂̕ϐ <--

	WAVEHDR* m_pWavehdr;	// OnMmWinData ŗ WAVE ̃obt@

	bool m_bExistGogo;	// ߌ̂` dll H

	bool m_bIniModified;// I INI ۑKvH

	int m_curNum;		// ݎgpĂobt@ (0`BUF_NUM-1)
	bool m_bRecording;	// ^H
	int m_dispMode;		// \[h 1:Level  2:Spectrum

	bool m_bCheckWav;	// CButton m_CheckWav; ɘA
	bool m_bCheckMp3;	// CButton m_CheckMp3; ɘA
	bool m_bCheckWma;	// CButton m_CheckMp3; ɘA
	bool m_bCheckNormalize;	// CButton m_CheckNormalize; ɘA
	bool m_bCheck4844;	// CButton m_Check4844; ɘA
	bool m_bCheckTimestamp;	// CButton m_CheckTimestamp; ɘA
	bool m_bCheckPowerdown;	// CButton m_CheckPowerdown; ɘA
	int m_nNormalizeLevel; // KxB0 ȂKɁB

	DWORD m_nPriGapLen;	// ȑO̖Tv
	DWORD m_nPostGapLen;	// Ȍ̖Tv

	int m_nThreadPriority ;	// ϊXbh̃vCIeB

	ULONG m_waveLen;	// WAVE t@C̃f[^̒ (bytes)
						// ^ɑĂāAŌ WAVEwb_ɏށB

	DWORD m_dwCurLevel;	// ݂̃x
	DWORD m_dwSilentCount;	// (1024Tv1)

	DWORD m_dwPeak;		// ݂܂ł̍ő僌x
	DWORD m_nTimestamp;	// ^Jn(time_t)

	FILE* m_fp;				// ^t@C̃fXNv^
	CString m_strFilename;	// ^t@C̃t@C
	int m_fileNum;			// ^t@C̏
	CString m_strFilepre;	// ^t@Cړ
	CString m_strFld;		// ^t@C̃tH_

	int m_nSilent;		// 0   1 L  2 s

	bool m_bSkip;		// ݂̋ȂXLbvB

	bool m_bTimerSetByIniFile;	// ^C}ݒt@CŐݒ肳Ă
								// JnɃ^C}ZbgȂBiʓ|j
	CTime m_timerStart;	//  
	CTime m_timerEnd;
	UINT m_nTimer;		// SetTimer ŕԂ^C}ʎq
	int m_nTimerStatus;	// ^C} 0: 1:Jn҂ 2:~҂ 3:~(dؒffp)

	// fobOp
	FILE* m_fpDebugLog;
	CString m_strDebugLogFileName;
	int m_nDebugLogLevel;


	// Xbhp
	// Xbh̊TO͒mĂǁA͏߂āB
	// MSDN Lib. Ɛ킢܂B܂łĂȂB
	CWinThread* m_pMp3Thread;
	CEvent m_Event;
	CMutex m_Mutex;
	CStringArray m_strAryWavFilename;
	CUIntArray   m_uintAryWavPeak;
	CUIntArray   m_uintAryTimestamp;

	SGogoSetting m_GogoSetting;

// Cve[V
public:
	void ReadIni();
	void WriteIni();

	//void waveInProc( HWAVEIN hwi, UINT uMsg, DWORD dwParam1, DWORD dwParam2 );

	void LowAudioClose();

	void WavFileOpen();
	void WavFileClose();

	void DispModeCheck();		// WI{^\ɔf
	void SamplingRateCheck();	// WI{^\ɔf

	void SetTimerStatusText(CString str);

	// void Mp3FileOpen(CString strFilename, const SGogoSetting& GogoSetting);
	// void Mp3FileClose();

protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CSRecDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnRec();
	afx_msg void OnStop();
	afx_msg void OnBtnRef();
	afx_msg void OnChangeEditFilepre();
	afx_msg void OnChangeEditFld();
    afx_msg LRESULT OnMmWinData(WPARAM wParam, LPARAM lParam);
	afx_msg void OnRadioSpectrum();
	afx_msg void OnRadioLevel();
	afx_msg void OnCheckMp3();
	afx_msg void OnCheckWav();
	afx_msg void OnBtnThreshold();
	afx_msg void OnKillfocusEditThreshold();
	afx_msg void OnCheckNormalize();
	afx_msg void OnCheck4844();
	afx_msg void OnRadio32();
	afx_msg void OnRadio44();
	afx_msg void OnRadio48();
	afx_msg void OnClose();
	afx_msg void OnBtnGogoconf();
	afx_msg void OnBtnSkip();
	afx_msg void OnBtnTimer();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnCheckTimestamp();
	afx_msg void OnCheckStartnow();
	afx_msg void OnCheckPowerdown();
	afx_msg BOOL OnQueryEndSession();
	afx_msg LRESULT OnMp3ThreadEnd(WPARAM, LPARAM);
	afx_msg void OnKillfocusEditSilentTimeSpan();
	afx_msg void OnBtnAbout();
	afx_msg void OnCheckWma();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_SRECDLG_H__B240D0F7_54E2_11D2_86C6_00A0C925E3DC__INCLUDED_)
